/**
 * 
 */
package com.diagbot.facade;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.AddTagRetrievalDTO;
import com.diagbot.dto.GetRetrievalsByTagDTO;
import com.diagbot.entity.Retrieval;
import com.diagbot.entity.RetrievalMapping;
import com.diagbot.service.impl.RetrievalServiceImpl;
import com.diagbot.vo.AddTagRetrievalVO;
import com.diagbot.vo.DelRetrievalsByMapsVO;
import com.diagbot.vo.GetRetrievalsByTagVO;

/**
 * @Description
 * @author rgb
 * @time 2018年12月5日下午4:53:59
 */
@Component
public class RetrievalFacede extends RetrievalServiceImpl {
	
	@Autowired
	private RetrievalMappingFacede retrievalMappingFacede;
	
	/**
	 * 根据标签获取同义词
	 * @param getRetrievalsByTagVO
	 * @return
	 */
	public List<GetRetrievalsByTagDTO> getRetrievalsByTag(GetRetrievalsByTagVO getRetrievalsByTagVO){
		
		return this.baseMapper.getRetrievalsByTag(getRetrievalsByTagVO);
	}

	/**
	 * 根据映射关系删除标签的同义词
	 * @param delRetrievalsByMapsVO
	 * @return
	 */
	public Boolean delRetrievalsByMaps(DelRetrievalsByMapsVO delRetrievalsByMapsVO){
		retrievalMappingFacede.removeByIds(delRetrievalsByMapsVO.getRetrievalMappingIds());
		return true;
	}
	
	/**
	 * 标签添加同义词
	 * @param addTagRetrievalVO
	 * @return
	 */
	public AddTagRetrievalDTO addTagRetrieval(AddTagRetrievalVO addTagRetrievalVO) {
		AddTagRetrievalDTO addTagRetrievalDTO = new AddTagRetrievalDTO();
		QueryWrapper<Retrieval> queryWrapper = new QueryWrapper<Retrieval>();
		queryWrapper.eq("name", addTagRetrievalVO.getRetrievalName());
		queryWrapper.eq("is_deleted", "N");
		Retrieval retrieval = this.getOne(queryWrapper);
		if(retrieval==null){
			retrieval = new Retrieval();
			retrieval.setName(addTagRetrievalVO.getRetrievalName());
			this.save(retrieval);
		}else{
			QueryWrapper<RetrievalMapping> queryWrapper2 = new QueryWrapper<RetrievalMapping>();
			queryWrapper2.eq("retrieval_id", retrieval.getId());
			queryWrapper2.eq("question_id", addTagRetrievalVO.getQuestionId());
			retrievalMappingFacede.remove(queryWrapper2);
		}
		
		RetrievalMapping retrievalMapping = new RetrievalMapping();
		retrievalMapping.setQuestionId(addTagRetrievalVO.getQuestionId());
		retrievalMapping.setRetrievalId(retrieval.getId());
		retrievalMappingFacede.save(retrievalMapping);
		
		addTagRetrievalDTO.setRetrievalId(retrieval.getId());
		addTagRetrievalDTO.setRetrievalMappingId(retrievalMapping.getId());
		return addTagRetrievalDTO;
	}
	
}
